<?php

function urlparse($post) {
    $urlSA = array(
      "/([^]_a-z0-9-=\"'\/])((https?|ftp|gopher|news|telnet):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si",
      "/^((https?|ftp|gopher|news|telnet):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si"
    );

    $urlRA = array(
      "\\1[url]\\2\\4[/url]",
      "[url]\\1\\3[/url]"
    );

    $emailSA = array(
      "/([ \n\r\t])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,3}))/si",
      "/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,3}))/si"
    );

    $emailRA = array(
      "\\1[email]\\2[/email]",
      "[email]\\0[/email]"
    );

  $text = preg_replace($urlSA, $urlRA, $post);
  if (strpos($text, "@")) {
    $text = preg_replace($emailSA, $emailRA, $text);
  }
  return $text;
}

function formatpost($post) {
    $post = stripslashes($post);
    $post = htmlspecialchars($post);
    $post = nl2br($post);
    
    $post = urlparse($post);

    $post = str_replace("[hr]","<hr>",$post);
    $post = str_replace("[b]","<b>",$post);
    $post = str_replace("[/b]","</b>",$post);
    $post = str_replace("[i]","<i>",$post);
    $post = str_replace("[/i]","</i>",$post);
    $post = str_replace("[u]","<u>",$post);
    $post = str_replace("[/u]","</u>",$post);
    $post = str_replace("[code]","<pre><font size=2>",$post);
    $post = str_replace("[/code]","</font></pre>",$post);
    $post = str_replace("[center]","<center>",$post);
    $post = str_replace("[/center]","</center>",$post);
    $post = str_replace("[img]","<img border=0 src=",$post);
    $post = str_replace("[/img]",">",$post);
    $post = str_replace("[quote]","<blockquote><font size=-2>Quote:<br><b>",$post);
    $post = str_replace("[/quote]","</b></font></blockquote>",$post);
    $post = eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]","<a href=\"http://www.\\1\" target=_blank>\\1</a>",$post);
    $post = eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" target=_blank>\\1</a>",$post);
    $post = preg_replace("#\[url=(.*?)\](.*?)\[/url\]#si", '<a href="\1" target="_blank">\2</A>', $post);
    $post = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]","<a href=\"mailto:\\1\">\\1</a>",$post);
    $post = str_replace("^0","<font color=#000000>",$post);
    $post = str_replace("^1","<font color=#FF0000>",$post);
    $post = str_replace("^2","<font color=#00FF00>",$post);
    $post = str_replace("^3","<font color=#FFFF00>",$post);
    $post = str_replace("^4","<font color=#0000FF>",$post);
    $post = str_replace("^5","<font color=#FF00FF>",$post);
    $post = str_replace("^6","<font color=#FF3280>",$post);
    $post = str_replace("^7","<font color=#FFFFFF>",$post);
    $post = str_replace("^8","<font color=#000000>",$post);
    $post = str_replace("^9","<font color=#FF0000>",$post);
    $post = str_replace("^f","</font>",$post);

    return $post;
}

function color_switch($i,$c_line1,$c_line2) {
 if(($i/2)==floor($i/2)) {
  $color="$c_line1";
 } else {
  $color="$c_line2";
 }
 return $color;
}

?>
